<template>
  <v-card
    @keydown.esc="submit(false)"
    @keydown.enter="submit(true)"
  >
    <v-toolbar
      color="error"
      flat dark
    >
      <v-icon left>
        mdi-alert
      </v-icon>
      <v-toolbar-title>
        {{ $t(`dialogs.warning.dialog.${message}.title`) }}
      </v-toolbar-title>
    </v-toolbar>

    <v-card-text class="body">
      <i18n :path="`dialogs.warning.dialog.${message}.text`">
        <template #contact>
          <a :href="contactMailUrl">{{ $t('dialogs.warning.slots.contact') }}</a>
        </template>
        <template #path>
          {{ path ? `: '${path}'` : '.' }}
        </template>
      </i18n>
    </v-card-text>

    <v-card-actions v-if="confirm">
      <v-btn
        color="primary"
        text
        @click="submit(false)"
      >
        {{ $t('dialogs.warning.buttons.cancel') }}
      </v-btn>
      <v-spacer />
      <v-btn
        color="warning"
        text
        @click="submit(true)"
      >
        {{ $t('dialogs.warning.buttons.validate') }}
      </v-btn>
    </v-card-actions>
    <v-card-actions v-else>
      <v-spacer />
      <v-btn
        color="primary"
        text
        @click="submit(true)"
      >
        {{ $t('dialogs.warning.buttons.close') }}
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, Emit,
} from 'vue-property-decorator';
import { contactMailUrl } from './mail';

@Component
export default class WarningDialog extends Vue {
  contactMailUrl = contactMailUrl;

  @Prop({ required: true })
  message!: string;

  @Prop()
  path?: string;

  @Prop()
  confirm?: boolean;

  @Prop()
  actions: unknown;

  @Emit()
  submit(value: boolean): boolean {
    return value;
  }
}
</script>
<style lang="scss" scoped>
.body {
  white-space: pre-line
}
</style>
